#!/usr/bin/perl
#
#               -------------
#				   Links
#               -------------
#               Links Manager
# 
#         File: admin_html.pl
#  Description: This library contains all the html used in the admin 
#               interface.
#       Author: Alex Krohn
#        Email: alex@gossamer-threads.com
#          Web: http://www.gossamer-threads.com/
#      Version: 1.11
#
# COPYRIGHT NOTICE:
#
# Copyright 1997 Gossamer Threads Inc.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified free of charge for personal, academic, government or non-profit
# use, so long as this copyright notice and the header above remain intact.
# Any commercial use should be registered.  Please also send me an email,
# and let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# Please check the README file for full details on registration.
# =====================================================================

##########################################################
##					  Globals							##
##########################################################

$body = qq|BODY BGCOLOR="#E0E0D2"|;

$html_search_options =  qq!
    <STRONG>ѡ: (ֶʹ "*" ۿм¼)</STRONG><BR>
    <INPUT TYPE="TEXT" NAME="keyword" SIZE=15 MAXSIZE=255> ؼ <INPUT TYPE="TEXT" NAME="mh" VALUE="$db_max_hits" SIZE=3 MAXSIZE=4> ¼<BR>
    <INPUT TYPE="CHECKBOX" NAME="ma"> ƥκ  <INPUT TYPE="CHECKBOX" NAME="cs"> ƥСд <INPUT TYPE="CHECKBOX" NAME="ww"> ƥؼ <INPUT TYPE="CHECKBOX" NAME="re"> ִģʽ
!;
         
$html_footer = qq!
        <h5 align=center>&copy 1998 <a href="http://oh.yeah.net/" target="_blank">Oh Yeah Net</a></h5>
!; 

##########################################################
##					  Adding					      ##
##########################################################

sub html_add_form {
# --------------------------------------------------------
# The add form page where the user fills out all the details
# on the new record he would like to add. You should use 
# &html_record_form to print out the form as it makes
# updating much easier. Feel free to edit &get_defaults
# to change the default values.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>һ¼¼</TITLE>
</HEAD>

<$body>
    <H2><TT>һ¼¼</TT></H2>
        <FORM ACTION="$db_script_url" METHOD="POST">
            |; &html_record_form (&get_defaults); print qq|
           <P><INPUT TYPE="HIDDEN" NAME="add_record" VALUE="1">
           <INPUT TYPE="SUBMIT" VALUE="Ӽ¼"> <INPUT TYPE="RESET" VALUE="">
         </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_add_success {
# --------------------------------------------------------
# The page that is returned upon a successful addition to
# the database. You should use &get_record and &html_record
# to verify that the record was inserted properly and to make
# updating easier.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>¼ɹ.</TITLE>
</HEAD>

<$body>
    <H2><TT>¼ɹ.</TT></H2>
    <P><Font face="Verdana, Arial, Helvetica" Size=2>м¼ѱɹݿ:</FONT>
|; &html_record(&get_record($in{$db_key})); print qq|   
    <P><Font face="Verdana, Arial, Helvetica" Size=2>?</FONT>
        <FORM ACTION="$db_script_url" METHOD="POST">
            |; &html_record_form (&get_defaults); print qq|
           <P><INPUT TYPE="HIDDEN" NAME="add_record" VALUE="1">
           <INPUT TYPE="SUBMIT" VALUE="Ӽ¼"> <INPUT TYPE="RESET" VALUE="">
         </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_add_failure {
# --------------------------------------------------------
# The page that is returned if the addition failed. An error message 
# is passed in explaining what happened in $message and the form is
# reprinted out saving the input (by passing in %in to html_record_form).

    my ($message) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>Error! ܼ¼.</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red">Error! ܼ¼.</FONT></TT></H2>
    <P>ֶδ: <FONT COLOR="red"><B>$message</B></FONT>
    <BR>дύһ.
    <P>
    <FORM ACTION="$db_script_url" METHOD="POST">
        |; &html_record_form (%in); print qq|
       <P><INPUT TYPE="HIDDEN" NAME="add_record" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="Ӽ¼"> <INPUT TYPE="RESET" VALUE="">
     </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_add_record_mult {
# --------------------------------------------------------
# This page is returned upon successful completion of check_links.
# It really ownly works with multiple category additions, but should
# be generalized to work with other databases.

	my ($categories) = @_;

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ɹ.</TITLE>
</HEAD>

<$body>
    <H2><TT>ɹ.</TT></H2>
    <P><Font face="Verdana, Arial, Helvetica" Size=2>ѱɹ:
	<strong>$categories</strong>
	</FONT>
	
    $html_footer
</BODY>
</HTML>
|;
}

##########################################################
##					  Viewing					     ##
##########################################################

sub html_view_search {
# --------------------------------------------------------
# This page is displayed when a user requests to search the 
# database for viewing. 

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ݿ.</TITLE>
</HEAD>

<$body>
    <H2><TT>ݿ.</TT></H2>
    <P>
    <FORM ACTION="$db_script_url" METHOD="GET">
    |;  &html_record_form(); print qq|
        <P>$html_search_options
        <P><INPUT TYPE="HIDDEN" NAME="view_records" VALUE="1">
        <INPUT TYPE="SUBMIT" VALUE="鿴¼"> <INPUT TYPE="RESET" VALUE="">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_view_success {
# --------------------------------------------------------
# This page displays the results of a successful search. The hits
# are stored in an array @hits and the number of hits is calculated
# and stored in $numhits.
# A little work must be done to convert each hit to a hash to pass off
# to html_record for printing.

    my ($i, $col, %tmp);
    my (@hits) = @_;
    my ($numhits) = ($#hits+1) / ($#db_cols+1);
    my ($maxhits) = $db_max_hits;
    $maxhits = $in{'mh'} if ($in{'mh'});
    
    &html_print_headers;    
    print qq|
<HTML>
<HEAD>
    <TITLE>.</TITLE>
</HEAD>

<$body>
    <H2><TT>.</TT></H2>
|;
    if ($numhits == $maxhits) {
        print qq|<P> <strong>$maxhits</strong> ¼.
				 <A HREF="$db_search_next_url"> $maxhits </a>?
				|;
    }
    else {
        print qq|<P> <strong>$numhits</strong> ¼:
				 <P>|;
    }

# Go through each hit and convert the array to hash and send to 
# html_record for printing.
    for ($i = 0; $i < $numhits; $i++) {
        %tmp = &array_to_hash ($i, @hits); 
        print "<P>";
        &html_record (%tmp);
    }

print qq|
        <P><CENTER><A HREF="$db_script_url?view_search=1">ٴ?</A></CENTER>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_view_failure {
# --------------------------------------------------------
# The search for viewing failed. The reason is stored in $message
# and a new search form is printed out.

    my ($message) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ʧ.</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red">ʧ.</FONT></TT></H2>
    <P>˴. ԭ: <FONT COLOR="red"><B>$message</B></FONT>
    <BR>дһ.
    <P>
    <FORM ACTION="$db_script_url" METHOD="GET">
        |; &html_record_form(); print qq|
        <P>$html_search_options
        <P><INPUT TYPE="HIDDEN" NAME="view_records" VALUE="1">
        <INPUT TYPE="SUBMIT" VALUE="鿴¼"> <INPUT TYPE="RESET" VALUE="">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

##########################################################
##					  Deleting					    ##
##########################################################

sub html_delete_search {
# --------------------------------------------------------
# The page is displayed when a user wants to delete records. First
# the user has to search the database to pick which records to delete.
# That's handled by this form.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ݿҪɾĲ.</TITLE>
</HEAD>

<$body>
    <H2><TT>ݿҪɾĲ.</TT></H2>
    <P>ݿҪɾļ¼
       <A HREF="$db_script_url?delete_form=1&$db_key=*">гȫ</a>:
    <P>
    <FORM ACTION="$db_script_url" METHOD="GET">
    |;  &html_record_form(); print qq|
        <P>$html_search_options
        <P><INPUT TYPE="HIDDEN" NAME="delete_form" VALUE="1">
        <INPUT TYPE="SUBMIT" VALUE=""> <INPUT TYPE="RESET" VALUE="">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_delete_form {
# --------------------------------------------------------
# The user has searched the database for deletion and must now
# pick which records to delete from the records returned. This page
# should produce a checkbox with name=ID value=delete for each record.
# We have to do a little work to convert the array @hits that contains
# the search results to a hash for printing.

    my ($status, @hits) = &query(); 
    my ($numhits) = ($#hits+1) / ($#db_cols+1);
    my ($maxhits) = $db_max_hits;
    $maxhits = $in{'mh'} if ($in{'mh'});
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ɾ¼.</TITLE>
</HEAD>

<$body>
    <H2><TT>ɾ¼.</TT></H2>
    <P>ѡҪɾļ¼Ȼ "ɾ¼":
|;

    if ($numhits == $maxhits) {
        print qq|<P> <strong>$maxhits</strong> ¼.
				 <A HREF="$db_search_next_url"> $maxhits </a>?
				|;
    }
    else {
        print qq|<P> <strong>$numhits</strong> ¼:
				 <P>|;
    }
    
print qq|<FORM ACTION="$db_script_url" METHOD="POST">
         <TABLE BORDER=1>|;

# Go through each hit and convert the array to hash and send to 
# html_record for printing. Also add a checkbox with name=key and value=delete.

    if ($status ne "ok") {  # There was an error searching!
        print qq|<TR><TD><FONT COLOR="RED" SIZE=4>Error: $status</FONT></TD></TR>|;
    }
    else {
# Print Column Headers
		print "<tr><th>$db_key</th>";	
		foreach $col (@db_record_header_columns) {
			print qq|<th>$col</th>|;
		}
		print "</tr>";

# Print Main Body.		
        for ($i = 0; $i < $numhits; $i++) {
            %tmp = &array_to_hash ($i, @hits);
            print qq|<TR><TD><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="delete"> $tmp{$db_key}</TD>|;
            &html_record_spreadsheet (%tmp);
            print qq|</TR>|;
        }
    }
print qq|
    </TABLE>
    <P><INPUT TYPE="HIDDEN" NAME="delete_records" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="ɾѡļ¼"> <INPUT TYPE="RESET" VALUE="">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_delete_success {
# --------------------------------------------------------
# This page let's the user know that the records were successfully
# deleted.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>¼ɹɾ.</TITLE>
</HEAD>

<$body>
    <H2><TT>¼ɹɾ.</TT></H2>
    <P>ļ¼Ѿɹݿɾ.
    $html_footer
</BODY>
</HTML>
|;
}

sub html_delete_failure {
# --------------------------------------------------------
# This page let's the user know that some/all of the records were
# not deleted (because they were not found in the database). 
# $errstr contains a list of records not deleted.

    my ($errstr) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>Error: ¼ܱɾ.</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red">Error! ¼ܱɾ.</FONT></TT></H2>
    <P>ݿûҵйؼֵļ¼: <FONT COLOR="red">$errstr</FONT>.
    $html_footer
</BODY>
</HTML>
|;  
}

##########################################################
##					  Modifying							##
##########################################################
sub html_modify_search {
# --------------------------------------------------------
# The page is displayed when a user wants to modify a record. First
# the user has to search the database to pick which record to modify.
# That's handled by this form.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ݿҪ޸ĵĲ.</TITLE>
</HEAD>

<$body>
    <H2><TT>ݿҪ޸ĵĲ.</TT></H2>
    <P>ݿҪ޸ĵļ¼
      <A HREF="$db_script_url?modify_form_mult=1&$db_key=*">гȫ</a>:
    <P>
    <FORM ACTION="$db_script_url" METHOD="GET">
    |;  &html_record_form(); print qq|
        <P>$html_search_options
        <P><INPUT TYPE="HIDDEN" NAME="modify_form_mult" VALUE="1">
        <INPUT TYPE="SUBMIT" VALUE=""> <INPUT TYPE="RESET" VALUE="">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_modify_form {
# --------------------------------------------------------
# The user has searched the database for modification and must now
# pick which record to modify from the records returned. This page
# should produce a radio button with name=modify value=ID for each record.
# We have to do a little work to convert the array @hits that contains
# the search results to a hash for printing.

    my ($status, @hits) = &query(); 
    my ($numhits) = ($#hits+1) / ($#db_cols+1);
    if ($numhits == 1) {            # Only one result, so let's modify it.
        $in{'modify'} = $hits[0];
        &html_modify_form_record();
    }
    else {
        my ($maxhits) = $db_max_hits;
        $maxhits = $in{'mh'} if ($in{'mh'});

        &html_print_headers;
        print qq|
<HTML>
<HEAD>
    <TITLE>޸ļ¼.</TITLE>
</HEAD>

<$body>
    <H2><TT>޸ļ¼.</TT></H2>
    <P>ѡҪ޸ĵļ¼Ȼ "޸ļ¼":
|;
# Print out how many hits, if maximum, produce a link to get next n hits.
    if ($numhits == $maxhits) {
        print qq|<P> <strong>$maxhits</strong> ¼.
				 <A HREF="$db_search_next_url"> $maxhits </a>?
				|;
    }
    else {
        print qq|<P> <strong>$numhits</strong> ¼:
				 <P>|;
    }
    
print qq|<P>
    <FORM ACTION="$db_script_url" METHOD="POST">
    <TABLE>|;

# Go through each hit and convert the array to hash and send to 
# html_record for printing. Also add a radio button with name=modify
# and value=key.
    if ($status ne "ok") {  # Error searching database!
        print qq|<TR><TD><FONT COLOR="RED" SIZE=4>Error: $status</FONT></TD></TR>|;
    }
    else {
        for ($i = 0; $i < $numhits; $i++) {
            %tmp = &array_to_hash ($i, @hits);
            print qq|<TR><TD><INPUT TYPE=RADIO NAME="modify" VALUE="$tmp{$db_key}"></TD><TD>|;
            &html_record (%tmp);
            print qq|</TD></TR>|;
        }
    }
print qq|
    </TABLE>
    <P><INPUT TYPE="HIDDEN" NAME="modify_form_record" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="޸ļ¼"> <INPUT TYPE="RESET" VALUE="">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
    }
}

sub html_modify_form_mult {
# --------------------------------------------------------
# Allows modification of more then one record at a time.
#
	my ($errstr, $succstr) = @_;
	
    my ($status, @hits) = &query(); 
    my ($numhits) = ($#hits+1) / ($#db_cols+1);
	my ($maxhits) = $db_max_hits;
	$maxhits = $in{'mh'} if ($in{'mh'});

	if ($numhits == 1) {
		$in{'modify'} = $hits[0];
		&html_modify_form_record();
		return;
	}
	
	&html_print_headers;
        print qq|
<HTML>
<HEAD>
    <TITLE>޸һ¼</TITLE>
</HEAD>

<$body>
    <H2><TT>޸һ¼</TT></H2>
|;
if ($errstr) {
	print qq|<font color=red><strong>$errstr</strong></font>|;
}
if ($succstr) {
	print qq|м¼ѱɹ޸: <font color=red><strong>$succstr</strong></font>.|;
}
else {
	print qq|	<P>
		<p>ѡ޸ĵļ¼Ȼ "޸ļ¼":|;

# Print out how many hits, if maximum, produce a link to get next n hits.
	    if ($numhits == $maxhits) {
	        print qq|<P> <strong>$maxhits</strong> ¼.
					 <A HREF="$db_search_next_url"> $maxhits </a>?
					|;
	    }   
print qq|
	    <FORM ACTION="$db_script_url" METHOD="POST">
	    <TABLE BORDER=1>|;
	
# We need to pre load the available categories so we don't search the database for
# every link! We store the results in $db_select_field so the script can use 
# &build_select_field as if it was a normal select field.	
	    if ($status ne "ok") {  # Error searching database!
	        print qq|<TR><TD><FONT COLOR="RED" SIZE=4>Error: $status</FONT></TD></TR>|;
	    }
	    else {
# Pre Load the category list.		
			$db_select_fields{'Category'} = $db_select_fields{'Related'} = join (",", &category_list);

# Print Column Headers
			print "<tr><th>$db_key</th>";
			foreach $col (@db_form_header_columns) {
				print qq|<th>$col</th>|;
			}
			print "</tr>";

# Print Main Body.		
	        for ($i = 0; $i < $numhits; $i++) {
	            %tmp = &array_to_hash ($i, @hits);
	            print qq|<TR><TD VALIGN=TOP><nobr><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="modify">$tmp{$db_key} </nobr></TD>|;
	            &html_record_form_spreadsheet (%tmp);
	            print qq|</TR>|;
	        }
			print "</table>";
	    }

# Print out how many hits, if maximum, produce a link to get next n hits.
	    if ($numhits == $maxhits) {
	        print qq|<P> <strong>$maxhits</strong> ¼.
				 <A HREF="$db_search_next_url"> $maxhits </a>?
					|;
	    }   	
print qq|
	    <P><INPUT TYPE="HIDDEN" NAME="modify_record_mult" VALUE="1">
	       <INPUT TYPE="SUBMIT" VALUE="޸ļ¼"> <INPUT TYPE="RESET" VALUE="">
	    </FORM>
    	|; 
	}
	print qq|$html_footer
</BODY>
</HTML>
|;
}

sub html_modify_form_record {
# --------------------------------------------------------
# The user has picked a record to modify and it should appear
# filled in here stored in %rec. If we can't find the record,
# the user is sent to modify_failure.

    my (%rec) = &get_record($in{'modify'});
    if (!%rec) { &html_modify_failure("ҵ¼/ûиü¼: $in{'modify'}"); }
    else {
        &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>޸һ¼</TITLE>
</HEAD>

<$body>
    <H2><TT>޸һ¼</TT></H2>
        <FORM ACTION="$db_script_url" METHOD="POST">
            |; &html_record_form (%rec); print qq|
           <P><INPUT TYPE="HIDDEN" NAME="modify_record" VALUE="1">
           <INPUT TYPE="SUBMIT" VALUE="޸ļ¼"> <INPUT TYPE="RESET" VALUE="">
         </FORM>
    $html_footer
</BODY>
</HTML>
|;
    }
}

sub html_modify_success {
# --------------------------------------------------------
# The user has successfully modified a record, and this page will 
# display the modified record as a confirmation.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>¼ɹ޸.</TITLE>
</HEAD>

<$body>
    <H2><TT>¼ɹ޸.</TT></H2>
    <P><Font face="Verdana, Arial, Helvetica" Size=2>м¼ѱɹ޸:</FONT>
    |; &html_record(&get_record($in{$db_key})); print qq|
    $html_footer
</BODY>
</HTML>
|;
}

sub html_modify_failure {
# --------------------------------------------------------
# There was an error modifying the record. $message contains
# the reason why.

    my ($message) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>Error! ޸ļ¼.</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red">Error! ޸ļ¼.</FONT></TT></H2>
    <P>޸ļ¼: <FONT COLOR="red"><B>$message</B></FONT>
    <BR>дһ.
    <P>
    <FORM ACTION="$db_script_url" METHOD="POST">
        |; &html_record_form (%in); print qq|
       <P><INPUT TYPE="HIDDEN" NAME="modify_record" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="޸ļ¼"> <INPUT TYPE="RESET" VALUE="">
     </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

##########################################################
##					  Validation						##
##########################################################
sub html_validate_form {
# --------------------------------------------------------
# This page produces a list of records waiting to be validated, 
# from which the admin can either delete, or validate the records.

# First let's just get a list of all the records to validate/modify.
    my (@lines, @valhits, @modhits, $numhits, $counter);
    
    open (VALIDATE, "<$db_valid_name") or &cgierr("ܴ֤ļ: $db_valid_name. ԭ: $!");    
        @lines = <VALIDATE>;
    close VALIDATE; 
    LINE: foreach $line (@lines) {
        next LINE if ($line =~ /^#/); next LINE if ($line =~ /^\s*$/);
        push (@valhits, &split_decode($line));
    }
    open (MODIFY, "<$db_modified_name") or &cgierr("ܴ֤ļ: $db_valid_name. ԭ: $!");    
        @lines = <MODIFY>;
    close MODIFY; 
    LINE: foreach $line (@lines) {
        next LINE if ($line =~ /^#/); next LINE if ($line =~ /^\s*$/);
        push (@modhits, &split_decode($line));
    }	
    $numhits = (($#valhits+1) + ($#modhits+1)) / ($#db_cols+1);

# Now let's print out the page:     
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>֤¼.</TITLE>
</HEAD>

<$body>
    <H2><TT>֤¼.</TT></H2>
    <P>ѡм¼ ($numhits) Ҫ֤ļ¼Ȼ "֤¼". <br>
	   ͬһʾ 10 ¼.<br>
	   Ҫ֤, ȻһµĴԤվ.
    <FORM ACTION="$db_script_url" METHOD="POST">
         <TABLE BORDER=1>|;
# Print Column Headers
		print "<tr><th>Action</th>";
		foreach $col (@db_form_header_columns) {
			print qq|<th>$col</th>|;
		}
		print "</tr>";
		
# Pre Load Category List
	$db_select_fields{'Category'} = join (",", &category_list);

# Counter, we only want to display 10 at a time.
	$counter = 0;

# Go through each validated hit and convert the array to hash and send to 
# html_record for printing. Also add a checkbox with name=key and value=delete.
    for ($i = 0; $i < ($#valhits+1) / ($#db_cols+1); $i++) {
		last if (++$counter > 10);
        %tmp = &array_to_hash ($i, @valhits);
        print qq|<TR><TD>
<PRE><a href="$tmp{'URL'}" target="_blank">֤</a>: <INPUT TYPE="RADIO" NAME="$tmp{$db_key}" VALUE="validate">
ɾ: <INPUT TYPE="RADIO" NAME="$tmp{$db_key}" VALUE="delete"></PRE></TD>|;
        &html_record_form_spreadsheet (%tmp);
        print qq|</TD></TR>|;		
    }

# Go through each modified hit and convert the array to hash and send to 
# html_record for printing. Also add a checkbox with name=key and value=delete.
    for ($i = 0; $i < ($#modhits+1) / ($#db_cols+1); $i++) {
		last if (++$counter > 10);
        %tmp = &array_to_hash ($i, @modhits);
        print qq|<TR><TD>
<PRE><a href="$tmp{'URL'}" target="_blank">޸</a>: <INPUT TYPE="RADIO" NAME="$tmp{$db_key}" VALUE="modify">
ɾ: <INPUT TYPE="RADIO" NAME="$tmp{$db_key}" VALUE="delete"></PRE></TD>|;
        &html_record_form_spreadsheet (%tmp);
        print qq|</TD></TR>|;
    }


print qq|
    </TABLE>
    <P><INPUT TYPE="HIDDEN" NAME="validate_records" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="֤/ɾ ѡļ¼"> <INPUT TYPE="RESET" VALUE="">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_validate_success {
# --------------------------------------------------------
# This page let's the user know that the records were successfully
# validated.
	my ($valsuc, $modsuc, $delsuc) = @_;
	
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>¼ѱ֤/ɾ.</TITLE>
</HEAD>

<$body>
    <H2><TT>¼ѱ֤/ɾ.</TT></H2>
    <P>|; 
	
print "м¼ѱɹ֤: $valsuc<br>" if ($valsuc);
print "м¼ѱɹ޸: $modsuc<br>" if ($modsuc);
print "м¼ѱɹɾ: $delsuc<br>" if ($delsuc);
print qq|
$html_footer
</BODY>
</HTML>
|;
}

sub html_validate_failure {
# --------------------------------------------------------
# This page let's the user know that some/all of the records were
# not validated (because they were not found in the database). 
# $errstr contains a list of records not deleted.

    my ($errstr) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>Error: ֤¼.</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red">Error! ֤¼.</FONT></TT></H2>
    <P>֤д:
	<FONT COLOR="red">	
	<ul>
	$errstr
	</ul>
	</FONT>.
    <P>|; 
	
print "м¼ѱɹ֤: $valsuc<br>" if ($valsuc);
print "м¼ѱɹ޸: $modsuc<br>" if ($modsuc);
print "м¼ѱɹɾ: $delsuc<br>" if ($delsuc);
print qq|	
$html_footer
</BODY>
</HTML>
|;  
}

##########################################################
##					  Email Messages					##
##########################################################

sub html_validate_email {
# --------------------------------------------------------
# All the link information is stored in %link.
	my (%link) = @_;

if ($db_use_sockets) {
###################################
# <--BEGIN SMTP SOCKET SECTION -->#
###################################

($x,$x,$x,$x, $here) = gethostbyname($void);
($x,$x,$x,$x, $there) = gethostbyname($def_smtp_server);
$myserver = pack('S n a4 x8',2,0,$here);
$sendserver = pack('S n a4 x8',2,25,$there);
#NOTE, if Solaris, uncomment the line below and delete the one below it...leave alone for NT
#(!(socket(S,2,2,6))) && (&cgierr('Connect error!'));
(!(socket(S,2,1,6))) && (&cgierr('Connect error!'));
(!(bind(S,$myserver))) && (&cgierr('Connect error!'));
(!(connect(S,$sendserver))) && (&cgierr("!! connection to $def_smtp_server has failed!"));

select(S); 
$| = 1; 
select(STDOUT);

$DATA_IN = <S>;	
($DATA_IN !~ /^220/) && (&cgierr('Connect error - aborted')); 
#>>>>>>
print S "HELO tg\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Connect error - aborted')); 
#<<<<<<<<
print S "MAIL FROM:<$db_admin_email>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr("'From' address not valid")); 
#<<<<<<<<<<<<<<<
print S "RCPT TO:<$link{'Contact Email'}>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Recipient address not valid')); 
#<<<<<<<<<<<<<<<
print S "DATA\n";
$DATA_IN = <S>;
($DATA_IN !~ /^354/) && (&cgierr('Message send failed - try again')); 
#<<<<<<<<<<<<<<<
print S <<EOF;
From: $db_admin_email
To: $link{'Contact Name'} <$link{'Contact Email'}>
Subject: վѾݿ!뱣ôż!

лĵ¼!վѼݿ,:
------------------------------------------------------------------
  : $link{'Title'}
   URL: $link{'URL'}
  : $link{'Category'}
  : $link{'Description'}
ϵ: $link{'Contact Name'}
 Email: $link{'Contact Email'}
-------------------------------------------------------------------
Դµӿ½:
$build_root_url
-------------------------------------------------------------------
"Cool Site",ֻѡеһ,뵽ҳ:
ͼ400x40
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsiteb.gif" width="400" height="40"></a>
ͼ88x31:
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsitem.gif" width="88" height="31"></a>
ͼ40x40:
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsites.gif" width="40" height="40"></a>
-------------------------------------------------------------------  
´,Ҳһͬ뵽ҳȥ,ֵĸл!
<table border="0" width="280" bgcolor="#E0E0D2">
  <tr>
    <td width="220" height="1" valign="middle" align="center"><form method="GET" action="http://oh.yeah.net/person/search.cgi">
      <div align="left"><p><br>
      <input type="text" name="query" size="20"> <input type="submit" value="" style="background-color: rgb(160,208,208)"></p>
      </div>
    </form>
    </td>
    <td width="80" height="1" valign="middle" align="center"><p align="left"><a href="http://www.netease.com/~elvis/person/add.htm">¼վ</a><br>
    <a href="http://www.netease.com/~elvis/search.htm">Ѵ</a></td>
  </tr>
</table>
-------------------------------------------------------------------
ҳϵĿ:
[CGIԴ]CGIվ.

-------------------------------------------------------------------
,ʱϵ: ICQ:6964606 Email:elvis\@126.com
οҳ: http://oh.yeah.net  еذļ.
-------------------------------------------------------------------

.
EOF

$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Message send failed - try again')); 
#<<<<<<<<<<<<<<<
print S "QUIT\n";

####################################
#  <--END SMTP SOCKET SECTION -->  #
####################################

####################################
#<--START UNIX SENDMAIL SECTION -->#
####################################
}
else
{
	open (MAIL, "|$db_mail_path") or &cgierr ("unable to open mail: $db_mail_path. Reason: $!");
	print MAIL "To: $link{'Contact Name'} <$link{'Contact Email'}>\n";
	print MAIL "From: $db_admin_email\n";
	print MAIL "Subject: վѾݿ!뱣ôż!\n\n";
	print MAIL qq|
лĵ¼!վѼݿ,:
------------------------------------------------------------------
  : $link{'Title'}
   URL: $link{'URL'}
  : $link{'Category'}
  : $link{'Description'}
ϵ: $link{'Contact Name'}
 Email: $link{'Contact Email'}
-------------------------------------------------------------------
Դµӿ½:
$build_root_url
-------------------------------------------------------------------
"Cool Site",ֻѡеһ,뵽ҳ:
ͼ400x40
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsiteb.gif" width="400" height="40"></a>
ͼ88x31:
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsitem.gif" width="88" height="31"></a>
ͼ40x40:
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsites.gif" width="40" height="40"></a>
-------------------------------------------------------------------  
´,Ҳһͬ뵽ҳȥ,ֵĸл!
<table border="0" width="280" bgcolor="#E0E0D2">
  <tr>
    <td width="220" height="1" valign="middle" align="center"><form method="GET" action="http://oh.yeah.net/person/search.cgi">
      <div align="left"><p><br>
      <input type="text" name="query" size="20"> <input type="submit" value="" style="background-color: rgb(160,208,208)"></p>
      </div>
    </form>
    </td>
    <td width="80" height="1" valign="middle" align="center"><p align="left"><a href="http://www.netease.com/~elvis/person/add.htm">¼վ</a><br>
    <a href="http://www.netease.com/~elvis/search.htm">Ѵ</a></td>
  </tr>
</table>
-------------------------------------------------------------------
ҳϵĿ:
[CGIԴ]CGIվ.

-------------------------------------------------------------------
,ʱϵ: ICQ:6964606 Email:elvis\@126.com
οҳ: http://oh.yeah.net  еذļ.
-------------------------------------------------------------------

|;
print MAIL "\cZ" if ($db_sendmail eq "win");                               # ǽţʹãʹSendMailһֱ

	close MAIL;
}
}

sub html_modify_email {
# --------------------------------------------------------
# All the link information is stored in %link.
	my (%link) = @_;

if ($db_use_sockets) {
###################################
# <--BEGIN SMTP SOCKET SECTION -->#
###################################

($x,$x,$x,$x, $here) = gethostbyname($void);
($x,$x,$x,$x, $there) = gethostbyname($def_smtp_server);
$myserver = pack('S n a4 x8',2,0,$here);
$sendserver = pack('S n a4 x8',2,25,$there);
#NOTE, if Solaris, uncomment the line below and delete the one below it...leave alone for NT
#(!(socket(S,2,2,6))) && (&cgierr('Connect error!'));
(!(socket(S,2,1,6))) && (&cgierr('Connect error!'));
(!(bind(S,$myserver))) && (&cgierr('Connect error!'));
(!(connect(S,$sendserver))) && (&cgierr("!! connection to $def_smtp_server has failed!"));

select(S); 
$| = 1; 
select(STDOUT);

$DATA_IN = <S>;	
($DATA_IN !~ /^220/) && (&cgierr('Connect error - aborted')); 
#>>>>>>
print S "HELO tg\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Connect error - aborted')); 
#<<<<<<<<
print S "MAIL FROM:<$db_admin_email>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr("'From' address not valid")); 
#<<<<<<<<<<<<<<<
print S "RCPT TO:<$link{'Contact Email'}>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Recipient address not valid')); 
#<<<<<<<<<<<<<<<
print S "DATA\n";
$DATA_IN = <S>;
($DATA_IN !~ /^354/) && (&cgierr('Message send failed - try again')); 
#<<<<<<<<<<<<<<<
print S <<EOF;
From: $db_admin_email
To: $link{'Contact Name'} <$link{'Contact Email'}>
Subject: Ѿ!ô!

л"Oh Yeah Net"ĵ¼!Ҫ,ѾΪ:
-------------------------------------------------------------------
  : $link{'Title'}
   URL: $link{'URL'}
  : $link{'Category'}
  : $link{'Description'}
ϵ: $link{'Contact Name'}
Email: $link{'Contact Email'}
-------------------------------------------------------------------
Դµӿ½:
  $build_root_url
-------------------------------------------------------------------
"Cool Site",ֻѡеһ,뵽ҳ:
ͼ400x40
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsiteb.gif" width="400" height="40"></a>
ͼ88x31:
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsitem.gif" width="88" height="31"></a>
ͼ40x40:
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsites.gif" width="40" height="40"></a>
-------------------------------------------------------------------  
´,Ҳһͬ뵽ҳȥ,ֵĸл!
<table border="0" width="280" bgcolor="#E0E0D2">
  <tr>
    <td width="220" height="1" valign="middle" align="center"><form method="GET" action="http://oh.yeah.net/person/search.cgi">
      <div align="left"><p><br>
      <input type="text" name="query" size="20"> <input type="submit" value="" style="background-color: rgb(160,208,208)"></p>
      </div>
    </form>
    </td>
    <td width="80" height="1" valign="middle" align="center"><p align="left"><a href="http://www.netease.com/~elvis/person/add.htm">¼վ</a><br>
    <a href="http://www.netease.com/~elvis/search.htm">Ѵ</a></td>
  </tr>
</table>
-------------------------------------------------------------------
ҳϵĿ:
[CGIԴ]CGIվ.

-------------------------------------------------------------------
,ʱϵ: ICQ:6964606 Email:elvis\@126.com
οҳ: http://oh.yeah.net  еذļ.
-------------------------------------------------------------------

.
EOF

$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Message send failed - try again')); 
#<<<<<<<<<<<<<<<
print S "QUIT\n";
####################################
#  <--END SMTP SOCKET SECTION -->  #
####################################
}
else
{
####################################
#<--START UNIX SENDMAIL SECTION -->#
####################################
	open (MAIL, "|$db_mail_path") or &cgierr ("unable to open mail: $db_mail_path. Reason: $!");
	print MAIL "To: $link{'Contact Name'} <$link{'Contact Email'}>\n";
	print MAIL "From: $db_admin_email\n";
	print MAIL "Subject: Ѿ!ô!\n\n";
	print MAIL qq|
л"Oh Yeah Net"ĵ¼!Ҫ,ѾΪ:
-------------------------------------------------------------------
  : $link{'Title'}
   URL: $link{'URL'}
  : $link{'Category'}
  : $link{'Description'}
ϵ: $link{'Contact Name'}
Email: $link{'Contact Email'}
-------------------------------------------------------------------
Դµӿ½:
  $build_root_url
-------------------------------------------------------------------
"Cool Site",ֻѡеһ,뵽ҳ:
ͼ400x40
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsiteb.gif" width="400" height="40"></a>
ͼ88x31:
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsitem.gif" width="88" height="31"></a>
ͼ40x40:
   <a href="http://oh.yeah.net/person/jump.cgi?HM=CoolSite&amp;ID=$link{'ID'}" target="_blank"><img src="http://www.netease.com/~elvis/coolsites.gif" width="40" height="40"></a>
-------------------------------------------------------------------  
´,Ҳһͬ뵽ҳȥ,ֵĸл!
<table border="0" width="280" bgcolor="#E0E0D2">
  <tr>
    <td width="220" height="1" valign="middle" align="center"><form method="GET" action="http://oh.yeah.net/person/search.cgi">
      <div align="left"><p><br>
      <input type="text" name="query" size="20"> <input type="submit" value="" style="background-color: rgb(160,208,208)"></p>
      </div>
    </form>
    </td>
    <td width="80" height="1" valign="middle" align="center"><p align="left"><a href="http://www.netease.com/~elvis/person/add.htm">¼վ</a><br>
    <a href="http://www.netease.com/~elvis/search.htm">Ѵ</a></td>
  </tr>
</table>
-------------------------------------------------------------------
ҳϵĿ:
[CGIԴ]CGIվ.

-------------------------------------------------------------------
,ʱϵ: ICQ:6964606 Email:elvis\@126.com
οҳ: http://oh.yeah.net  еذļ.
-------------------------------------------------------------------
 
|;
print MAIL "\cZ" if ($db_sendmail eq "win");                               # ǽţʹãʹSendMailһֱ

	close MAIL;
}
}

##########################################################
##					  Misc								##
##########################################################

sub html_check_links {
# --------------------------------------------------------
# This routine checks to make sure that there are no links w/o
# associated categories.
#

	my ($bad_category, @bad_links) = @_;
    my ($numhits) = ($#bad_links+1) / ($#db_cols+1);
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>.</TITLE>
</HEAD>

<$body>
    <H2><TT>: Ѱûйļ¼.</TT></H2>
|;
    if (!$bad_category) {
        print qq|<P>ûзκ!|;
    }
    else {
        print qq|<P>ݿУһЩһЩݿе
					.  <b></b> ɾ, ȱٵ.
				 <P>Ҫ, ѡҪӵѡ, ȻӰť. Ҫ
				    ɾ, ѡҪɾȻɾť. (<strong>ע: Ϊ $db_max_hits Ҫ
					ɾ</strong>).
			     <FORM ACTION="$db_script_url/category" METHOD="POST">
				 <SCRIPT LANGUAGE="Javascript">
				 <!--
				 	function check_all () {
						var loop = 0;
						for (loop=0; loop < window.document.forms[0].elements.length; loop++) {							
							window.document.forms[0].elements[loop].checked = true;
						}
					}
					
					function clear_all () {
						var loop = 0;
						for (loop=0; loop < window.document.forms[0].elements.length; loop++) {							
							window.document.forms[0].elements[loop].checked = false;
						}
					}						
				// -->
				 </SCRIPT>
				 <P><INPUT TYPE=BUTTON VALUE="ѡȫ" OnClick="check_all(); return true;">
				    <INPUT TYPE=BUTTON VALUE="ȫ" OnClick="clear_all(); return true;"></P>
				 <P>
				 <TABLE BORDER=1>$bad_category</TABLE>
				 <P><INPUT TYPE="HIDDEN" NAME="add_record_mult" VALUE="1">
				 <INPUT TYPE="SUBMIT" VALUE="ѡ"> <INPUT TYPE="RESET" VALUE=""></FORM>
				 <hr width=100% size=1 noshade>
				 <p>ҪɾЧ, ѡǵУȻɾ:
    			 <FORM ACTION="$db_script_url/links" METHOD="POST">
		         <TABLE BORDER=1>
		|;
		# Print Column Headers
				print "<tr><th>Delete</th>";
				foreach $col (@db_record_header_columns) {
					print qq|<th>$col</th>|;
				}
		print "</tr>";
		for ($i = 0; $i < $numhits; $i++) {
			%tmp = &array_to_hash ($i, @bad_links);
			print qq|<TR><TD><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="delete"></TD>|;
			&html_record_spreadsheet (%tmp);
			print qq|</TR>|;
		}
		print qq|
			    </TABLE>
			    <P><INPUT TYPE="HIDDEN" NAME="delete_records" VALUE="1">
			       <INPUT TYPE="SUBMIT" VALUE="ɾѡļ¼"> <INPUT TYPE="RESET" VALUE="">
			    </FORM>
	    |; 
	}
	print qq|
	$html_footer
</BODY>
</HTML>
|;
}

sub html_check_duplicates {
# --------------------------------------------------------
# This routine checks to see if there are any duplicate links.
#

	my (@dup_links) = @_;
    my ($numhits) = ($#dup_links+1) / ($#db_cols+1);
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ͬ.</TITLE>
</HEAD>

<$body>
    <H2><TT>: Ѱͬ.</TT></H2>
|;
	if (!$numhits) {
		print "<P>ûзͬ!";
	}
	else {
		print qq|
			 <p>ҪɾЧ, ѡǵУȻɾ:
	 		<FORM ACTION="$db_script_url/links" METHOD="POST">
		     <TABLE BORDER=1>
		|;
# Print Column Headers
		print "<tr><th>ɾ</th>";
		foreach $col (@db_record_header_columns) {
			print qq|<th>$col</th>|;
		}
		print "</tr>";
	
		for ($i = 0; $i < $numhits; $i++) {
			%tmp = &array_to_hash ($i, @dup_links);
			print qq|<TR><TD><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="delete"></TD>|;
			&html_record_spreadsheet (%tmp);
			print qq|</TR>|;
		}
		print qq|
		    </TABLE>
			    <P><INPUT TYPE="HIDDEN" NAME="delete_records" VALUE="1">
			       <INPUT TYPE="SUBMIT" VALUE="ɾѡļ¼"> <INPUT TYPE="RESET" VALUE="">
			    </FORM>
	    |; 
	}
	print qq|
	$html_footer
</BODY>
</HTML>
|;
}

sub html_unkown_action {
# --------------------------------------------------------
# The program received a command it did not recognize.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>Error! δ֪.</TITLE>
</HEAD>

<$body>
    <H2><TT>Error! δ֪.</TT></H2>
    <P>ݿյδ. ס, HTMLļ
	   ִг, 䱾.  
     $html_footer       
</BODY>
</HTML>
|;
}

1;