#!/usr/bin/perl
#
#               -------------
#		  Emailizer
#               -------------
#
#         File: nph-emailizer.cgi
#  Description: This library contains all procedures that allow administrators to 
#               email preformatted messages to all users(or a part).
#       Author: Christian Leporati
#               via Medaglie d'oro 1 - I-41012 - Carpi (MO) - Italy
#        Email: lepo@web-linker.com
#          (c): alex@gossamer-threads.com http://www.gossamer-threads.com/
#               this is a free impletentation that could be added to LINKS 1.1 by 
#               gossamer-threads all right reserved. 
#          Web: http://web-linker.com/lepolinks
#      Version: 1.10a
#
# W A R N I N G !   
# I strongly encourage to add into your Links database a new filed 
# named  "isPromotion" [Yes,No]. And let people decide to recieve or not your 
# bulk email. Remember to pay attention emailizing. Sould be really dangerous. 
# In this code there is some commented line you should use when "isPromotion" is
# active. 
#
# COPYRIGHT NOTICE:
#
# Copyright 1997 Gossamer Threads Inc.  All Rights Reserved.
#
# This program is being distributed as "postcardware".  It may be used and
# modified so long as this copyright notice and the header above remain intact.
# Any use should be registered sending a postcard to Christian Leporati. 
# Please let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. and web-linker.com from any 
# liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# =====================================================================

# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \

    require "links.cfg";					# Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db.pl";           # Database Routines.
    require "$db_lib_path/site_html.pl";    # Get Admin HTML routines.
    require "$db_lib_path/admin_html.pl";   
};
if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
	exit;
}

# ========================================================

eval { &main; };					        # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }     # never produces that nasty 500 server error page.
exit;   # There are only two exit calls in the script, here and in in &cgierr. 


sub main {
# --------------------------------------------------------
    $| = 1;		# Must flush output.
    #&html_print_headers;

    local($succstr, $errstr);
    local(%in)   = &parse_form;	# Get Form Results

       if ($in{'email_form_mult'})	{ &html_email_form_mult; }	
    elsif ($in{'email_record_mult'})	{ &email_record_mult; }		
    else 
	  { &html_email_search; }	

}


sub email_record_mult {
# --------------------------------------------------------
# e-mail to many people.
#
	my (%email_listm, $succstr, $errstr);
	my ($line, @lines, $id, @rest, $output, $message_to_email_tmp);
	my ($rec_to_email) = 0;

	my ($time) = &get_time;
	my ($date) = &get_date;

	print qq|
<html>
<head>
<title>ʼ</title>
</head>
<body bgcolor="#E0E0D2">
    <$font><FONT SIZE=4>ʼ</FONT></font><BR>
    <P><$font>ʼҪ <b>ʱ</b> ȥĹ. ĵȴֱʼ.
       <font color=blue>ɫ</font> ʾü¼ʼѱȷ, <font color=red>ɫ</font> ʾʼʧ.</font>
    <p><$font>̿ʼ [$date][$time]...<BR>
 |;	
  
        	foreach $key (keys %in) 		# Build a hash of keys to email.
                 {       if ($in{$key} eq "email") 
                           {       $email_list{$key} = 1;
	          		   $rec_to_email = 1;
		           }
	         }

        	if (!$rec_to_email) 
                 {
		      &html_email_form_mult("You must mark at least one record to be emailed.");
   	         }	
                else 
                {
                 open (DB, "<$db_file_name") or &cgierr("error in records. unable to open db file: $db_file_name. Reason: $!");
 	         @lines = <DB>;
    	         close DB;		
		
		LINE: foreach $line (@lines)
                  {
		     if ($line =~ /^$/) { next LINE; }
		     if ($line =~ /^#/) { $output .= $line; next LINE; }
		     chomp ($line);			
		     (@rec) = &split_decode($line);
		     if ($email_list{$rec[0]}) 
                      {  
                        if(   (length($rec[$db_contact_email]) < 5)  ||  #  an e-mail address must have more than 4 chars to be emailed
                              (length($rec[$db_contact_name]) < 3 )  ||  #  a name  must have more than 2 chars to be emailed
                              ($rec[$db_promotion] =~ /^No/)    )        #  a record must have $db_promotion switch ON to be emailed
                                                                           # You can add this feature by your own so people can decide 
                                                                           # to recieve or recieve NOT your bulk emails. 
                                                                           # to do that just add a files named isPromotion and make it 
                                                                           # works just like "isPop"; then let users see this variable 
                                                                           # and modify it during the "add" and "modify resource" filling 
                                                                           # procedure. 
                          {  
                            if ($in{'is_debug'} ne "yes") 
                               {  print  "<font color=red>$rec[0] ($rec[$db_contact_email])</font><BR>"; 
                                  $errstr .= "$rec[0] ";
                               }
                               else 
                               {  print  "<hr><font color=red>$rec[0]</font>\n\n "; }
                          }

                         else 
                          {
                            $message_to_email_tmp = $in{'message_to_email_body'};

                                 $message_to_email_tmp =~ s/%%ID%%/$rec[0]/mig;
                                 $message_to_email_tmp =~ s/%%category%%/$rec[$db_category]/mig;
                                 $message_to_email_tmp =~ s/%%modified%%/$rec[$db_modified]/mig;
                                 $message_to_email_tmp =~ s/%%url%%/$rec[$db_url]/mig;
                                 $message_to_email_tmp =~ s/%%hits%%/$rec[$db_hits]/mig;
                                 $message_to_email_tmp =~ s/%%isnew%%/$rec[$db_isnew]/mig;
                                 $message_to_email_tmp =~ s/%%ispop%%/$rec[$db_ispop]/mig;
                                 $message_to_email_tmp =~ s/%%contact_name%%/$rec[$db_contact_name]/mig;
                                 $message_to_email_tmp =~ s/%%contact_email%%/$rec[$db_contact_email]/mig;

                             if ($in{'is_debug'} ne "yes") 
                                { print qq|<font color=blue>$rec[0] ($rec[$db_contact_email]) 
				           $rec[$db_contact_name] - $rec[$db_url]</font><BR>
 				          |;
                               #
                               # here's we are... current configurazion CAN SEND email to the whole comunity. 
                               # remember that this program is really dangerous and people don't like very much this 
                               # kind of jokes. KEEP ALWAIS IN MIND how MANY spam messages you recieve every week,
                               # THINK about it!
                               #
                               # I strongly recomend to activate DEMOCRACY.CGI into your LINKS program. Should prevent 
                               # a lot of problems. (http://web-linker.com/lepolinks)
                               #
                                  sleep 1 ;

if ($db_use_sockets) {
###################################
# <--BEGIN SMTP SOCKET SECTION -->#
###################################
($x,$x,$x,$x, $here) = gethostbyname($void);
($x,$x,$x,$x, $there) = gethostbyname($def_smtp_server);
$myserver = pack('S n a4 x8',2,0,$here);
$sendserver = pack('S n a4 x8',2,25,$there);
####
#NOTE, if Solaris, uncomment the line below and delete the one below it...leave alone for NT
#and most UNIX systems
#(!(socket(S,2,2,6))) && (&cgierr('Connect error!'));
####
(!(socket(S,2,1,6))) && (&cgierr('Connect error!'));

(!(bind(S,$myserver))) && (&cgierr('Connect error!'));
(!(connect(S,$sendserver))) && (&cgierr("!! connection to $def_smtp_server has failed!"));

select(S); 
$| = 1; 
select(STDOUT);

$DATA_IN = <S>;	
($DATA_IN !~ /^220/) && (&cgierr('Connect error - aborted')); 
#>>>>>>
print S "HELO tg\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Connect error - aborted')); 
#<<<<<<<<
print S "MAIL FROM:<$in{$db_cols[$db_contact_email]}>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr("'From' address not valid")); 
#<<<<<<<<<<<<<<<
print S "RCPT TO:<$db_admin_email>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Recipient address not valid')); 
#<<<<<<<<<<<<<<<
print S "DATA\n";
$DATA_IN = <S>;
($DATA_IN !~ /^354/) && (&cgierr('Message send failed - try again')); 
#<<<<<<<<<<<<<<<

print S <<EOF;
From: $db_admin_email
To: $rec[$db_contact_name] <$rec[$db_contact_email]>
Subject: $in{'message_to_email_subject'}

$message_to_email_tmp
.
.
EOF

$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Message send failed - try again')); 
print S "QUIT\n";

#<<<<<<<<<<<<<<<
####################################
#  <--END SMTP SOCKET SECTION -->  #
####################################
}
else
{




                                  open (MAIL, "|$db_mail_path") or &cgierr ("unable to open mail: $db_mail_path. Reason: $!");
                        	  print MAIL "To: $rec[$db_contact_name] <$rec[$db_contact_email]>\n";
                           	  print MAIL "From: $db_admin_email\n";
                        	  print MAIL "Subject: $in{'message_to_email_subject'}\n\n"; 
                	          print MAIL $message_to_email_tmp;
				  print MAIL "\cZ" if ($db_sendmail eq "win");   # ǽţʹãʹWIN -SendMailһֱ

                                  close (MAIL);
}

                                }
                              else 
                                  { print "<hr><PRE><font color=black SIZE=1>$message_to_email_tmp</font></pre>\n\n";   
                                  }

                            $succstr .= "$rec[0] ";
                         } 

                     } # end of if ($email_list{$rec[0]}) 
	          } # end of LINE: foreach $line (@lines)
                }


$time = &get_time; 
$date = &get_date;

if ($db_use_sockets) {
###################################
# <--BEGIN SMTP SOCKET SECTION -->#
###################################
($x,$x,$x,$x, $here) = gethostbyname($void);
($x,$x,$x,$x, $there) = gethostbyname($def_smtp_server);
$myserver = pack('S n a4 x8',2,0,$here);
$sendserver = pack('S n a4 x8',2,25,$there);
####
#NOTE, if Solaris, uncomment the line below and delete the one below it...leave alone for NT
#and most UNIX systems
#(!(socket(S,2,2,6))) && (&cgierr('Connect error!'));
####
(!(socket(S,2,1,6))) && (&cgierr('Connect error!'));

(!(bind(S,$myserver))) && (&cgierr('Connect error!'));
(!(connect(S,$sendserver))) && (&cgierr("!! connection to $def_smtp_server has failed!"));

select(S); 
$| = 1; 
select(STDOUT);

$DATA_IN = <S>;	
($DATA_IN !~ /^220/) && (&cgierr('Connect error - aborted')); 
#>>>>>>
print S "HELO tg\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Connect error - aborted')); 
#<<<<<<<<
print S "MAIL FROM:<$in{$db_cols[$db_contact_email]}>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr("'From' address not valid")); 
#<<<<<<<<<<<<<<<
print S "RCPT TO:<$db_admin_email>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Recipient address not valid')); 
#<<<<<<<<<<<<<<<
print S "DATA\n";
$DATA_IN = <S>;
($DATA_IN !~ /^354/) && (&cgierr('Message send failed - try again')); 
#<<<<<<<<<<<<<<<

if ($in{'is_debug'} eq "yes") {
print S <<EOF;
From: ʼͳ <$db_admin_email>
To: $db_admin_email
Subject: ʼ־

ʼ־
---------------------------------------------

ģʽ - ûʼ -

.
.
EOF
}
else
{
print S <<EOF;
From: ʼͳ <$db_admin_email>
To: $db_admin_email
Subject: ʼ־ 
          
ʼ־
---------------------------------------------

ʼɹ͵¼¼: $succstr
---------------------------------------------
ܷ͵¼¼: $errstr
---------------------------------------------

Ϣ:
---------------------------------------------
$in{'message_to_email_body'}
---------------------------------------------

Զ:  $ENV{'REMOTE_HOST'}
ʱ  :  [$date]  -  [$time]

--Ϣ--
.
.
EOF
}

$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Message send failed - try again')); 
print S "QUIT\n";

#<<<<<<<<<<<<<<<
####################################
#  <--END SMTP SOCKET SECTION -->  #
####################################
}
else
{

open (MAIL, "|$db_mail_path") or &cgierr ("unable to open mail: $db_mail_path. Reason: $!");
       	  print MAIL "To: $db_admin_email\n"; 
       	  print MAIL "From: ʼͳ <$db_admin_email>\n";
          print MAIL "Subject: ʼ־\n\n"; 
          print MAIL qq|
ʼ־
---------------------------------------------
|;
          print MAIL qq|
ģʽ - ûʼ -
|   if ($in{'is_debug'} eq "yes"); 
 
          print MAIL qq|

ʼɹ͵¼¼: $succstr
---------------------------------------------
ܷ͵¼¼: $errstr
---------------------------------------------

Ϣ:
---------------------------------------------
$in{'message_to_email_body'}
---------------------------------------------

Զ:  $ENV{'REMOTE_HOST'}
ʱ  :  [$date]  -  [$time]

--Ϣ--
|;
print MAIL "\cZ" if ($db_sendmail eq "win");   # ǽţʹãʹWIN -SendMailһֱ

close (MAIL);

}

print qq|
<hr>
<$font>EMAIL ־ѷ͸Ա.</font>
|;

print qq|
<p><$font>! [$time]
<p><font color="red"><b>!</b></font> ʱʼ͵Ľ! 
ǿҽ鵱һκδʱ <B>رյǰ</B> .<BR> 
</font>
</BODY>
</HTML>
|;

}



sub html_email_search {
# --------------------------------------------------------
# The page is displayed when a user wants to emailize. First
# the user has to search the database to pick which record to emailize.
# That's handled by this form.
# Tags used ------------------------------------------------------------
# is_debug [on/off]:       tells to the emailizer if the administrator 
#                          wants to operate in debug mode. 
# whole_database[yes/no]:  if turned off the program sends e-mail to 
#                          the whole database without refining

 print qq|
<HTML>
<HEAD>
    <TITLE>ʼݿ.</TITLE>
</HEAD>

<$body>
    <$font><FONT SIZE=4>ʼݿ.</font></font><BR>
       ݿҪʼļ¼
      <A HREF="$db_dir_url/nph-emailizer.cgi?email_form_mult=1&$db_key=*">гȫ</a>:
    <FORM ACTION="$db_dir_url/nph-emailizer.cgi" METHOD="GET">
    |;  &html_record_form(); print qq|
        <P>$html_search_options
        <P>
    <table border = 0>
      <tr> 
       <td valign=top> <INPUT TYPE = "checkbox" NAME = "whole_database" VALUE = "yes" CHECKED></td>
       <td valign=top> <$font><font size="2"><B>ȷ</B> </font></font></td>
      </tr>
      <tr>
       <td valign=top> <INPUT TYPE = "checkbox" NAME = "is_debug" VALUE = "yes" CHECKED></td>
       <td valign=top> <$font><font size="2"><B>ģʽ</B> (ʼ).</font></font></td>
      </tr>
      </table>
  
        <P><INPUT TYPE="HIDDEN" NAME="email_form_mult" VALUE="1">
           <INPUT TYPE="SUBMIT" VALUE=""> <INPUT TYPE="RESET" VALUE="">
    </FORM>
    <center><$font><a href="http://oh.yeah.net" target="_"><b>Oh Yeah Net</b></a></font></center>
</BODY>
</HTML>|;
}

sub html_record_form_spreadsheet_email {
# --------------------------------------------------------
# Displays a record in a one row format

	my (%rec) = @_;
	my ($font) = qq|Font face="Verdana, Arial, Helvetica" Size=1 Color=#003399|;
	
	print qq|
   
           <td><$font>                  $rec{'Title'}              </td></font>
           <td><$font><font color="red">$rec{'Contact Name'}</font></td></font>
           <td><$font>                  $rec{'Contact Email'}      </td></font>
       |;
}         

# Spreadsheet header columns
     @db_form_header_columns_email = ("Title", "Name", "E-mail");




sub html_email_form_mult {
# --------------------------------------------------------
# Allows modification of more then one record at a time.
#
	my ($status, @hits) = &query(); 
	my ($numhits) = ($#hits+1) / ($#db_cols+1);
	my ($maxhits) = $db_max_hits;
	$maxhits = $in{'mh'} if ($in{'mh'});

        print qq|
<HTML>
<HEAD>
    <TITLE>ʼ</TITLE>
</HEAD>

<$body>
    <$font><FONT SIZE=4>ʼ</FONT></font><BR>

                 <font color=blue size=1>$succstr</font></font>
	    <FORM ACTION="$db_dir_url/nph-emailizer.cgi" METHOD="POST">
	    <TABLE BORDER="0" cellpadding="3" cellspacing="0">|;
	
            print qq|<$font><font color=red><b>ģʽ</b></font> ѱ!</font><BR>
                    | if ($in{'is_debug'});


	    if ($status ne "ok") {  # Error searching database!
	        print qq|<TR><TD><FONT COLOR="RED" SIZE=4>Error: $status</FONT></TD></TR>|;
	    }
            
           else 
            {
             if ($in{'whole_database'} eq "yes")
                 {
                     print qq|<$font><font color=red><b>ȷģʽ</b></font> ѱ! 
                               ѡҪųļ¼.</font>
                             |; 
                     # Print Column Headers
			print "<tr><td><$font><b>$db_key</b></font></td>";
			foreach $col (@db_form_header_columns_email) {
				print qq|<td><$font><b>$col</b></font></td>|;
			}
			print "</tr>";
                     # Print Main Body.		
        	        for ($i = 0; $i < $numhits; $i++) {
	                    %tmp = &array_to_hash ($i, @hits);
	                    print qq|<TR><TD VALIGN=TOP><nobr><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="email" CHECKED><$font>$tmp{$db_key}</font> </nobr></TD>|;
	                    &html_record_form_spreadsheet_email (%tmp);
	                    print qq|</TR>|;
	                }
                     # Print out how many hits, if maximum, produce a link to get next n hits.
              	        print qq|<P><$font>Ϊ <strong>$maxhits</strong> ¼.
		                 <A HREF="$db_search_next_url"> $maxhits</a> ?</font>
         		        | if ($numhits == $maxhits);

	        	print "</table>";
	          }
                else 
                  {
                   print qq|<$font>ҵ <b>$numhits</b> ¼.</font><BR>|;
       	            for ($i = 0; $i < $numhits; $i++) 
                      {      %tmp = &array_to_hash ($i, @hits);
	                     print qq|<INPUT TYPE="HIDDEN" NAME="$tmp{$db_key}" VALUE="email">|;
                      }
                  }
            }

print qq|
	    <P>
              <table border=0>
              <tr><td valign="top">
              <$font><B>дҪ͵Ϣ</b>.<BR>
              Ϣʹбʾ¼ĸϢǩ:<p>   
              <$font>
              %%ID%%            <BR>
              %%category%%      <BR>
              %%modified%%      <BR>
              %%url%%           <BR>
              %%hits%%          <BR>
              %%isnew%%         <BR>
              %%ispop%%         <BR>
              %%contact_name%%  <BR>
              %%contact_email%% <BR>
             </font>
             </td>
             <td>
             <$font><font color=blue></font></font><BR> 
             <INPUT TYPE="TEXT" NAME="message_to_email_subject" VALUE="" SIZE="50" MAXLENGTH="100"><BR>
             <$font><font color=blue></font></font><BR> 
             <TEXTAREA NAME="message_to_email_body" ROWS="15" COLS="50" WRAP="VIRTUAL" MAXLENGTH="7000"></TEXTAREA>
             </td>
             </tr>
             </table>
             <P><$font>ʼҪ <b>ʱ</b> ȥĹ. ĵȴֱʼѷ.</font>
             <P> 
               <INPUT TYPE = "HIDDEN" NAME = "email_record_mult" VALUE="1">
               <INPUT TYPE = "HIDDEN" NAME = "whole_database" VALUE = "$in{'whole_database'}">
               <INPUT TYPE = "HIDDEN" NAME = "is_debug" VALUE = "$in{'is_debug'}" CHECKED>
	       <INPUT TYPE = "SUBMIT" VALUE= "ʼ"> <INPUT TYPE="RESET" VALUE="">
	    </FORM>
    	|; 

        #&cgierr("Done") if ($in{'is_debug'} eq "yes"); # after ver 0.1.0 this line will be commented

	print qq|    <center><$font><a href="http://oh.yeah.net" target="_"><b>Oh Yeah Net</b></a></font></center>
</BODY>
</HTML>
|;
}



